﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FilmStripScanNamer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private struct Operation
        {
            public FileInfo source;
            public string target;
        }        

        private IEnumerable<Operation> DetermineOperations()
        {            
            DirectoryInfo directory = new DirectoryInfo(inputDirectory.Text);
            FileInfo[] files = directory.GetFiles();

            var filtered =
                from file in files
                where (file.Attributes & FileAttributes.Hidden) == 0
                orderby file.Name
                group file by file.Extension.ToLower() into fileGroup
                select fileGroup;            

            foreach (var filegroup in filtered) {
                int currentGroup = 1;
                int currentFile = 1;
                foreach (var file in filegroup)
                {
                    string newFilename = String.Format(
                        "scan{0}{3}.{1}.{2}", numSheetField.Value.ToString("0000"), 
                        currentGroup + (int)startGroupField.Value - 1, currentFile, 
                        sheetSuffixField.Text);
                    var op = new Operation();
                    op.source = file;
                    op.target = newFilename;
                    yield return op;

                    currentFile++;
                    if (currentFile > numFilesField.Value)
                    {
                        currentGroup++;
                        if (currentGroup > countGroupsField.Value)
                            break;
                        currentFile = 1;
                    }
                }
            }
        }

        private void UpdatePreview()
        {
            previewBox.Clear();
            try
            {
                foreach (var op in DetermineOperations())
                {
                    previewBox.Text = previewBox.Text + op.source + " => " + op.target + "\r\n";
                }
            }
            catch
            {
                previewBox.Text = "Source directory not valid.";
            }
        }

        private void outputControl_ValueChanged(object sender, EventArgs e)
        {
            UpdatePreview();
        }

        private void inputControl_ValueChanged(object sender, EventArgs e)
        {
            UpdatePreview();
        }

        private void button1_Click(object sender, EventArgs e)
        {            
            var dialog = new System.Windows.Forms.FolderBrowserDialog();
            dialog.SelectedPath = inputDirectory.Text;
            var result = dialog.ShowDialog();
            if (result == DialogResult.OK)
                inputDirectory.Text = dialog.SelectedPath;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            var dialog = new System.Windows.Forms.FolderBrowserDialog();
            dialog.SelectedPath = outputDirectory.Text;
            var result = dialog.ShowDialog();
            if (result == DialogResult.OK)
                outputDirectory.Text = dialog.SelectedPath;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (outputDirectory.Text == "") return;

            foreach (var op in DetermineOperations())
            {
                File.Move(op.source.FullName, Path.Combine(outputDirectory.Text, op.target + op.source.Extension));
            }
            UpdatePreview();
        }

        private void label4_Click(object sender, EventArgs e)
        {

        }
    }
}
